-- Retro Rocks by mathfacts@cox.net
-- http://members.cox.net/mathfacts
-- Septemebr 4th 2006

math.randomseed( math.random(os.time()) )
shot = Sound.load("sounds/shot.wav") ; explode = Sound.load("sounds/explode.wav")
ufoshot = Sound.load("sounds/ufoshot.wav") ;shipexplode = Sound.load("sounds/shipexplode.wav")
warning = Sound.load("sounds/warning.wav"); retro = Sound.load("sounds/retro.wav")
ufoshot2 = Sound.load("sounds/ufoshot2.wav") ; splash = Image.load("sounds/splash.png")
blank = Image.load("sounds/blank.png") ; triangle = Image.load("sounds/triangle.png") ;
splash2 = Image.load("sounds/splash2.png") ; background = Image.load("sounds/background.png")
hifile = "sounds/hiscore.txt" ; hi_score = 0 ; options_file = "sounds/options.txt"

-- misc variables
green = Color.new(0, 255, 0) ; white = Color.new(255, 255, 255) ;red = Color.new(255, 0, 0)
yellow = Color.new(255, 255, 0);grey = Color.new(75,75,75) ; ltblue = Color.new (0,255,255)
black = Color.new (0,0,0) ; color = green ; last_time = os.time() ; no_ship = 1
max_life = 4 ; life_tot = max_life ;  wave = 0 ;score = 0; dx = 0 ; back = 1
introv = 1; intro_time = os.time()
-- ship data
cur_angle=180 ; xoff = 240 ; yoff = 140 ; ship_scale = 2.5; vel = 2.5 ; turn = 5 ; bsx = { } ; bsy = { }
x = {-3,0,3,0,-3,-2,0,2} ; y = {-5,5,-5,-2,-5,-4,-8,-4}
xn = {-3,0,3,0,-2,0,2} ; yn = {-5,5,-5,-2,4,-4,-8,-4}
max_points = 5 ;  thrust = 0  ; thrust_dir =0; thrust_chg= 0 ; decay = .01; thrust_step = .125
step_rate = .2 ; step = 0 ; last_angle = 180 ; new_thrust_angle = 180
-- ship bullet data
bullet_xoff = 0 ; bullet_yoff = 0; bullet_vel = 4; max_bullet_dis = 60 ; bullet_ang = 0;last_shot = os.time();last_ship = os.time()
-- Rock Data
cleared_rocks = 0 ;scale1 = 8; scale2 = 6 ; scale3 = 3.5
r1x = {0,2,2,0,-2,-2,-3,0} ; r1y = {3,1,-1,-3,-2,0,1,3} ; r1_max = 8
r2x = {0,2,0,-2,0} ; r2y = {3,0,-3,0,3} ; r2_max = 5
r3x = {0,1,3,1,0,-1,-3,-1,0} ; r3y = {3,1,0,-1,-3,-1,0,1,3} ; r3_max = 9
r4x = {0,1,2,3,0,-3,-2,-1,0} ; r4y = {-1,-2,-2,0,3,0,-2,-2,-1} ; r4_max = 9
rock_xoff = { };rock_yoff = { };rock_angle = { };rock_vel = { };rock_scale = { };
rock_color = { } ; rock_draw = { } ;max_rock_vel = 2
rx = r1x ; ry = r1y; rnx = rx ; rny = ry ; max_rock_points = r1_max
colored_rocks = 1 ; start_rocks = 4 ; rock_cap = 6 ; rock_mod = 1 ; rock_type = 1
-- Ufo Data
ufox = {-2,-1,0,1,2,3,2,-1,-2} ; ufoy = {0,0,-1,-1,0,0,1,1,0} ; ufo_points = 9 ; ufo_vel = {1.25,1.5};
ufo_scale = {6.5,4.5} ; ufo_xoff = -10 ; ufo_yoff = math.random(200)+20 ; ufo_dir = 30 ;  ufo = 0 ; ufo_type = 1
ufo_shot_time = 1 ; spawn_time = 15
-- Ufo bullet
ufo_bullet_vel = {2,4};ufo_bullet_ang = 0 ; ufo_bullet_xoff = 0 ;ufo_bullet_yoff = 0
-- Crash test data
ship_hit = 0; rock_hit = 0; ufo_rock_hit = 0; hits = 0 ; col = 0 ; testx = { }; testy = { } ;
i = 0 ; j = 0  ;npol = 0 ; bxp = 0; byp = 0; xp1 =0 ;yp1 =0 ;cx = { } ; cy = { }

function intro()
   bt = 0
   while bt == 0 do
   if os.difftime (os.time(), intro_time) > 5 then
      introv = introv * -1 ; intro_time = os.time()
   end
   if introv == 1 then
     screen:clear();
     screen:blit(0,0,splash)
     screen:print(90,235, "<START> to play  <SELECT> for Options", green);
     screen:print(145,252,"members.cox.net/mathfacts",yellow)
     screen:print(210,22,"Hi Score",yellow) ; screen:print(225,8,hi_score,yellow);
     screen.flip() ;  screen.waitVblankStart()
   else
     screen:clear();
     screen:blit(0,0,splash2)
     screen:print(90,235, "<START> to play  <SELECT> for Options", green);
     screen:print(145,252,"members.cox.net/mathfacts",yellow)
     screen.flip() ;  screen.waitVblankStart()
   end
     pad = Controls.read()
      if pad ~= oldpad then
        if pad:start() then bt = 1 end
        if pad:circle() then help = 1 end
        if pad:select() then oldpad = pad ; options() end
      end
   end
end

function options()
   bt = 0
   while bt == 0 do
     pad = Controls.read()
      if pad ~= oldpad then
        if pad:up() then start_rocks = start_rocks +1; saved = 0 ; end
        if pad:down() then rock_cap = rock_cap +1 ; saved = 0 ; end
        if pad:left() then rock_type = rock_type + 1; saved = 0 ; end
        if pad:right() then spawn_time = spawn_time + 3; saved = 0 ; end
        if pad:triangle() then colored_rocks = colored_rocks * -1; saved = 0 ;  end
        if pad:circle() then back = back * -1; saved = 0 ; end
        if pad:square() then rock_mod = rock_mod +.25; saved = 0 ; end
        if pad:cross() then max_rock_vel = max_rock_vel +.5; saved = 0 ; end
        if pad:l() then max_life = max_life +1; saved = 0 ; end
        if pad:r() then hi_score = 0; savehi(); saved = 0 ; end
        if pad:select() then save_options(); saved = 1 ;end
        if pad:start() then bt = 1; end
      oldpad = pad
      end
        if start_rocks > 6 then start_rocks = 1 end
        if spawn_time > 30 then spawn_time = 3 end
        if rock_cap < start_rocks then rock_cap = start_rocks end
        if rock_cap > 6 then rock_cap = 1 end
        if rock_mod > 1.5 then rock_mod = 1 end
        if max_rock_vel > 2.5 then max_rock_vel = 1 end
        if max_life > 8 then max_life = 4 end
        if rock_type > 4 then rock_type = 1 end
        if rock_type == 1 then rx = r1x; ry = r1y ; rnx = rx ; rny = ry ; max_rock_points = r1_max end
        if rock_type == 2 then rx = r2x; ry = r2y ; rnx = rx ; rny = ry ; max_rock_points = r2_max end
        if rock_type == 3 then rx = r3x; ry = r3y ; rnx = rx ; rny = ry ; max_rock_points = r3_max end
        if rock_type == 4 then rx = r4x; ry = r4y ; rnx = rx ; rny = ry ; max_rock_points = r4_max end
        screen:clear()
        if back ==1 then screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false) end
        screen:print(20,15,"Retro Rocks Options",green)
        screen:print(55,30,"Up = Set number of starting rocks",green); screen:print(20,30,start_rocks,yellow)
        screen:print(55,50,"Down = Set maximum rocks (+1 for each completed wave)",green); screen:print(20,50,rock_cap,yellow)
        screen:print(55,70,"Left = Set the rock type",green)
        screen:print(55,90,"Right = Set the # of seconds for the UFO respawn",green); screen:print(20,90,spawn_time,yellow)
        screen:print(55,110,"Triangle = Multi-colored Rocks",green)
        if colored_rocks == -1 then screen:print(20,110,"OFF",yellow) else screen:print(20,110,"ON",yellow) end
        screen:print(55,130,"Circle = Toggle background",green);
        if back == -1 then screen:print(20,130,"OFF",yellow) else screen:print(20,130,"ON",yellow) end
        screen:print(55,150,"Square = Set maximum rock size",green); screen:print(20,150,rock_mod,yellow)
        screen:print(55,170,"Cross = Set maximum rock speed",green); screen:print(20,170,max_rock_vel,yellow)
        screen:print(55,190,"Left Trigger = Set maximum life",green); screen:print(20,190,max_life,yellow)
        screen:print(55,210,"Right Trigger = Reset High Score",green)
        screen:print(55,230,"Select = Save Options",green)
        if saved == 1 then screen:print(10,230,"Saved",yellow); end
        screen:print(170,3,"High Score = "..hi_score,green)
        rockclr = white ; if colored_rocks == 1 then rockclr = Color.new (math.random(205)+50,math.random(205)+50,math.random(205)+50) end
        for a = 1,max_rock_points -1 do
           screen:drawLine(rnx[a]*scale1*rock_mod+390, rny[a]*scale1*rock_mod+190, rnx[a+1]*scale1*rock_mod+390, rny[a+1]*scale1*rock_mod+190, rockclr)
        end
        life_tot = max_life; life()
        screen:print(20,255,"Press <START> to Play",green)
        screen.waitVblankStart()
        screen.flip()
   end
end

function reset_game()
  cur_angle=180; last_angle = 180; new_thrust_angle = 180 ; step =0 ; thrust = 0
  xoff = 240 ; yoff = 140 ; xn = {-3,0,3,0,-3} ; yn = {-5,5,-5,-2,-5}
  score = 0 ; life_tot = max_life ; no_ship = 1 ; hits = 0 ; max_rocks = 0
  wave = 0 ; db = 0; dbu = 0 ; ufo = 0 ; ufo_xoff = -10 ; ufo_yoff = math.random(200)+20
  loadhi()
end

function init()
  max_rocks = start_rocks + wave
  if max_rocks > rock_cap then max_rocks = rock_cap end
  make_rocks(1,max_rocks,scale1*rock_mod)
  wave = wave + 1
  cur_angle=180; last_angle = 180; new_thrust_angle = 180 ; step =0 ; thrust = 0 ;  xoff = 240 ; yoff = 140
end

-- x,y,# points,scale,x off, y off, inverse x/y, color, connect 2-5
function draw_points(pointsx,pointsy,maxpoints,to_scale,x_offset,y_offset,invx,invy,color,is_ufo)
   for a = 1,maxpoints-1 do
      screen:drawLine((invx*pointsx[a])*to_scale+x_offset, (invy*pointsy[a])*to_scale+y_offset,(invx*pointsx[a+1])*to_scale+x_offset, (invy*pointsy[a+1])*to_scale+y_offset, color)
   end
   if is_ufo == 1 then
      screen:drawLine((invx*pointsx[2])*to_scale+x_offset, (invy*pointsy[2])*to_scale+y_offset,(invx*pointsx[5])*to_scale+x_offset, (invy*pointsy[5])*to_scale+y_offset, color)
   end
end

function life()
   for l = 1,life_tot-1 do
      draw_points(x,y,5,1.5,465-l*15,15,1,-1,yellow,0)
   end
end

function rotate()
  for a = 1,max_points do
    r1 = math.sqrt((x[a]*x[a])+(y[a]*y[a]))
    angle = math.atan2(x[a],y[a])
    angle = angle + math.rad(cur_angle)
    xn[a] = r1 * math.sin(angle)
    yn[a] = r1 * math.cos(angle)
  end
end

function draw_ship(color)
   thrust = thrust - decay
   if thrust < 0 then thrust = 0 end
   if xoff > 455 then xoff = 25 end
   if xoff < 25 then xoff = 455 end
   if yoff > 245 then yoff = 25 end
   if yoff < 25 then yoff = 245 end
   draw_points(xn,yn,max_points,ship_scale,xoff,yoff,1,1,color,0)
   if boost == 1 then
      retro:play()
      boost = 0; tmp_max = max_points; max_points = 8 ;rotate(); max_points = tmp_max
         for a = 6,8 do
             bsx[a-5] = xn[a]; bsy[a-5] = yn[a] ;
         end
         draw_points(bsx,bsy,3,ship_scale,xoff,yoff,1,1,yellow,0);
   end
end

function draw_rock()
  for r = 1, max_rocks do
     if rock_draw[r] == 1 then
        rock_xoff[r] = rock_xoff[r] + rock_vel[r]*math.sin(math.rad(rock_angle[r]))
        rock_yoff[r] = rock_yoff[r] + rock_vel[r]*math.cos(math.rad(rock_angle[r]))
        if rock_xoff[r] > 480 then rock_xoff[r] = -15 end
        if rock_xoff[r] < -15 then rock_xoff[r] = 480 end
        if rock_yoff[r] > 272 then rock_yoff[r] = -15 end
        if rock_yoff[r] < -15 then rock_yoff[r] = 272 end
        for a = 1,max_rock_points -1 do
           screen:drawLine(rnx[a]*rock_scale[r]+rock_xoff[r], rny[a]*rock_scale[r]+rock_yoff[r], rnx[a+1]*rock_scale[r]+rock_xoff[r], rny[a+1]*rock_scale[r]+rock_yoff[r], rock_color[r])
        end
     end
  end
end

function make_ufo()
   hit_check = wave + start_rocks - 1 ; if hit_check > rock_cap then hit_check = rock_cap end
   if hits > ((hit_check) * 7/2) then
       if os.difftime (os.time(), last_ship) > spawn_time then
          ufo = 1; ufo_type = 1  ; warning:play()
          ufo_xoff = -10 ; ufo_yoff = math.random(200)+20 ; ufo_bullet_xoff = 0 ;ufo_bullet_yoff = 0
          if score > 2000 and math.random(2) == 2 then ufo_type = 2 ; end
       end
   end
end

function draw_ufo()
    ufo_xoff = ufo_xoff + ufo_vel[ufo_type]*math.sin(math.rad(ufo_dir))
    ufo_yoff = ufo_yoff + ufo_vel[ufo_type]*math.cos(math.rad(ufo_dir))
    if ufo_yoff > 220 then ufo_dir = 140; end
    if ufo_yoff < 20 then ufo_dir = 30; end
    if ufo_xoff > 480 then ufo = 0 ; last_ship = os.time() ; end
    draw_points(ufox,ufoy,ufo_points,ufo_scale[ufo_type],ufo_xoff,ufo_yoff,1,1,red,1)
end

function shoot_ufo()
    if os.difftime (os.time(), last_shot) > ufo_shot_time then
     if ufo_xoff > 1 then
       dbu = 1; ufo_bullet_xoff = ufo_xoff ; ufo_bullet_yoff = ufo_yoff ; last_shot = os.time()
       ufo_bullet_ang = (180/math.pi)*math.atan2((xoff-ufo_xoff), (yoff-ufo_yoff))
       if math.random(2) == 2 then mul = -1 else mul = 1 end
       if ufo_type == 1 then ufo_bullet_ang = ufo_bullet_ang + math.random(15) * mul end  -- accuracy
       if ufo_type == 2 then ufo_bullet_ang = ufo_bullet_ang + math.random(3) * mul end -- accuracy
       if ufo_type == 1 then ufoshot:play() else ufoshot2:play(); end
      end
    end
end

function draw_ufo_bullet()
   ufo_bullet_xoff = ufo_bullet_xoff + ufo_bullet_vel[ufo_type]*math.sin(math.rad(ufo_bullet_ang))
   ufo_bullet_yoff = ufo_bullet_yoff + ufo_bullet_vel[ufo_type]*math.cos(math.rad(ufo_bullet_ang))
   screen:fillRect(ufo_bullet_xoff,ufo_bullet_yoff, 3,3,red )
   if ufo_bullet_xoff < 0 or ufo_bullet_yoff < 0 or ufo_bullet_xoff > 480 or ufo_bullet_yoff > 272 then dbu = 0; end
end

function draw_bullet()
   bullet_dis = bullet_dis +1
   if bullet_dis > max_bullet_dis then db = 0; hit_it = 0 ;  end
   bullet_xoff = bullet_xoff + bullet_vel*math.sin(math.rad(bullet_ang))
   bullet_yoff = bullet_yoff + bullet_vel*math.cos(math.rad(bullet_ang))
   screen:fillRect(bullet_xoff,bullet_yoff, 2,2,yellow )
   if bullet_xoff < 0 then bullet_xoff = 480 end
   if bullet_yoff < 0 then bullet_yoff = 272 end
   if bullet_xoff > 480 then bullet_xoff = 0 end
   if bullet_yoff > 272 then bullet_yoff = 0 end
end

function make_rocks(start,qty,size)
  math.randomseed( math.random(os.time()) )
  for a = start,qty do
    rock_xoff[a] = math.random(450)+20
       while rock_xoff[a] > 175 and rock_xoff[a] < 315 do
          rock_xoff[a] = (math.random(450)+20);
       end
    rock_yoff[a] = math.random(272)
    rock_angle[a]= (math.random(60)+15)+ (90*(math.random(3)-1))
    rock_vel[a] = math.random(100*max_rock_vel)/100
    if rock_vel[a] < .5 then rock_vel[a] = .5 end
    rock_scale[a] = size
    rock_color[a] = Color.new (math.random(225)+30,math.random(200)+55,math.random(225)+30)
    if colored_rocks == -1 then rock_color[a] = white end
    rock_draw[a] = 1
  end
end

function analog()
  dx = pad:analogX()
  if dx < -32 then  bt = 1 ; end
  if dx > 32 then bt = 2 ; end
end

function did_crash()
  if crashed == 1 then
    shipexplode:play()
    crashed = 0 ;  life_tot = life_tot - 1 ; draw_crash()
    if life_tot == 0 then game_over() end
    cur_angle=180; last_angle = 180; new_thrust_angle = 180 ; step =0 ; thrust = 0
    xoff = 240 ; yoff = 140; thrust = 0 ;  no_ship = 1
  end
end

function draw_crash()
  cx[1]=xn[1];cx[2]=xn[2];cx[3]=xn[2];cx[4]=xn[3];cx[5]=xn[3];cx[6]=xn[4];cx[7]=xn[4];cx[8]=xn[1]
  cy[1]=yn[1];cy[2]=yn[2];cy[3]=yn[2];cy[4]=yn[3];cy[5]=yn[3];cy[6]=yn[4];cy[7]=yn[4];cy[8]=yn[1]
  xd = {-1.2, -.9, .7,1.1,.6,.8, -.6,-.9}; yd = {1,1.4,.6,.9,-.8,-.5,-.8,-.6}
  for c = 1, 30 do
    screen:clear()
    if back == 1 then screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false) end
    screen:print(15,8,"Wave " .. wave,yellow) ; screen:print(15,20,score,yellow); screen:print(225,8,hi_score,yellow)
    for a = 1, 8 do
      cx[a] = cx[a] + xd[a]; cy[a] = cy[a] +yd[a]
    end
    screen:drawLine(cx[1]*ship_scale+xoff, cy[1]*ship_scale+yoff, cx[2]*ship_scale+xoff, cy[2]*ship_scale+yoff, color)
    screen:drawLine(cx[3]*ship_scale+xoff, cy[3]*ship_scale+yoff, cx[4]*ship_scale+xoff, cy[4]*ship_scale+yoff, color)
    screen:drawLine(cx[5]*ship_scale+xoff, cy[5]*ship_scale+yoff, cx[6]*ship_scale+xoff, cy[6]*ship_scale+yoff, color)
    screen:drawLine(cx[7]*ship_scale+xoff, cy[7]*ship_scale+yoff, cx[8]*ship_scale+xoff, cy[8]*ship_scale+yoff, color)
    draw_rock(); life()
    if ufo == 1 then draw_ufo() end
    if dbu == 1 then draw_ufo_bullet() end
    if db == 1 then draw_bullet() end
    screen.waitVblankStart()
    screen.flip()
  end
end

function game_over()
   gx = {3,3,0,0,3,3,1,3,3,4,4,7,4,4,7,7,7,8,8,9,10,11,11,15,12,12,13,12,12,15} ;
   gy = {3,4,4,0,0,2,2,2,0,0,2,2,2,4,4,2,0,0,4,2,2,4,0,0,0,2,2,2,4,4}
   ox = {0,0,3,3,0,5,4,5,6,7,6,8,8,9,8,8,11,8,8,11,12,12,12,15,15,12,15}
   oy = {0,4,4,0,0,0,4,0,0,4,0,0,2,2,2,4,4,4,0,0,0,2,4,4,2,2,0 }
   for a = 1,30 do
      screen:clear()
      if back == 1 then screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false) end
      screen:print(225,8,score,yellow)
      if a <= 15 then sc = 15-a else sc = a- 15 end
      draw_points(gx,gy,30,sc,40,100,1,-1,green,0)
      screen.flip()
      screen.waitVblankStart()
   end
   for a = 1,30 do
      screen:clear()
      if back == 1 then screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false) end
      screen:print(225,8,score,yellow)
      if a <= 15 then sc = 15-a else sc = a- 15 end
      draw_points(gx,gy,30,15,40,100,1,-1,green,0)
      draw_points(ox,oy,27,sc,100,180,1,-1,green,0)
         if a == 30 then screen:print(250,235,"Press <START> to play again",green) end
      screen.flip()
      screen.waitVblankStart()
   end
   if score > hi_score then savehi(); end
   while not Controls.read():start() do
   end
   oldpad = pad
   reset_game()
   intro()
   init()
end

function set_thrust()
   thrust = thrust + thrust_chg
   xdelta = 0; ydelta = 0
   if new_thrust_angle ~= last_angle then
      xnew = thrust_chg*math.sin(math.rad(new_thrust_angle))
      ynew = thrust_chg*math.cos(math.rad(new_thrust_angle))
      xold = (thrust-thrust_chg)*math.sin(math.rad(last_angle))
      yold = (thrust-thrust_chg)*math.cos(math.rad(last_angle))
      xdelta = xnew + xold ; ydelta = ynew + yold
      thrust = math.sqrt((xdelta*xdelta)+(ydelta*ydelta))
      last_angle = math.deg(math.atan2(xdelta,ydelta))
    else
       xdelta = thrust*math.sin(math.rad(last_angle))
       ydelta = thrust*math.cos(math.rad(last_angle))
    end
    xoff = xoff + xdelta ; yoff = yoff + ydelta
    thrust_chg = 0
    if thrust > vel then thrust = vel; end
    if thrust < 0 then thrust = 0; end
end

function check_bullet_hit_rock()
   bxp = bullet_xoff ;  byp = bullet_yoff ; rock_hit = 0
   for r = 1, max_rocks do
      if rock_draw[r] ~=0 then
         if rock_hit == 0 then
            for t = 1, max_rock_points do
               testx[t] = ((rock_scale[r]+1) * rnx[t]) + rock_xoff[r]
               testy[t] = ((rock_scale[r]+1) * rny[t]) + rock_yoff[r]
            end
            check (max_rock_points, testx, testy, bxp, byp)
            if col == 1 then rock_hit = r; end
         end
      end
   end
   if rock_hit ~= 0 then hit_rock() end
end

function check_bullet_hit_ufo()
   bxp = bullet_xoff ;  byp = bullet_yoff ; ufo_hit = 0
   for t = 1, ufo_points do
      testx[t] = ((ufo_scale[ufo]+1) * ufox[t]) + ufo_xoff
      testy[t] = ((ufo_scale[ufo]+1) * ufoy[t]) + ufo_yoff
   end
   check (ufo_points, testx, testy, bxp, byp)
   if col == 1 then
      explode:play(); ufo_hit = 1; score = score + ufo *250; ufo = 0 ;db = 0; last_ship = os.time()
   end
end

function check_ship_hit()
   if no_ship ~= 1 then
     bxp = ufo_bullet_xoff ;  byp = ufo_bullet_yoff ; crashed = 0
        for t = 1, max_points do
           testx[t] = ((ship_scale+1) * xn[t]) + xoff
           testy[t] = ((ship_scale+1) * yn[t]) + yoff
        end
        check (max_points, testx, testy, bxp, byp)
           if col == 1 then  db = 0; crashed=1 ; dbu = 0; end
   end
end

function check_ufo_bullet_rock_hit()
      bxp = ufo_bullet_xoff ;  byp = ufo_bullet_yoff ; rock_hit = 0
      for r = 1, max_rocks do
         if rock_draw[r] ~=0 then
            if rock_hit == 0 then
               for t = 1, max_rock_points do
                 testx[t] = ((rock_scale[r]+1) * rnx[t]) + rock_xoff[r]
                 testy[t] = ((rock_scale[r]+1) * rny[t]) + rock_yoff[r]
               end
               check (max_rock_points, testx, testy, bxp, byp)
               if col == 1 then rock_hit = r; end
            end
         end
      end
      if rock_hit ~= 0 then ufo_rock_hit = 1; hit_rock() ; end
end

function hit_rock()
  if rock_hit ~= 0 then
     explode:play();rock_draw[rock_hit] = 0 ; hits = hits +1  ; hit_it = 0
     if ufo_rock_hit == 1 then dbu = 0 else db = 0 end
     if rock_scale[rock_hit] > scale3*rock_mod then
        if rock_scale[rock_hit] == scale1*rock_mod then
           if ufo_rock_hit ~= 1 then score = score + 10 end
           new_scale = scale2*rock_mod
        else
           new_scale = scale3*rock_mod
           if ufo_rock_hit ~= 1 then score = score + 25 end
        end
        for q = 1,2 do
           max_rocks = max_rocks + 1
           make_rocks(max_rocks,max_rocks, new_scale)
           rock_xoff[max_rocks] = rock_xoff[rock_hit]
           rock_yoff[max_rocks] = rock_yoff[rock_hit]
        end
     else
        if ufo_rock_hit ~= 1 then score = score + 50 end
     end
  end
  rock_hit = 0 ; ufo_rock_hit = 0
  hit_check = wave + start_rocks - 1 ; if hit_check > rock_cap then hit_check = rock_cap end
  if hits == hit_check * 7 then
     hits = 0 ; cleared_rocks = 1
  end
end

function crash_rock_check()
   ship_hit = 0
   for b = 1,max_points - 1 do
      bxp = (xn[b]*ship_scale)+xoff ;  byp = (yn[b]*ship_scale)+yoff
      for r = 1, max_rocks do
         if rock_draw[r] ~= 0 then
            if ship_hit == 0 then
               for t = 1, max_rock_points do
                 testx[t] = ((rock_scale[r]+1) * rnx[t]) + rock_xoff[r]
                 testy[t] = ((rock_scale[r]+1) * rny[t]) + rock_yoff[r]
               end
               check (max_rock_points, testx, testy, bxp, byp)
               if col == 1 then ship_hit = r; crashed = 1; rock_hit = r;  hit_rock() ; end
            end
         end
      end
   end
end

function crash_ufo_check()
   if ufo~= 0 and ship_hit == 0 then
      ufo_hit_ship = 0
      for b = 1,max_points -1 do
         bxp = (xn[b]*ship_scale)+xoff ;  byp = (yn[b]*ship_scale)+yoff
         if ufo_hit_ship == 0 then
            for t = 1, ufo_points do
               testx[t] = ((ufo_scale[ufo]+1) * ufox[t]) + ufo_xoff
               testy[t] = ((ufo_scale[ufo]+1) * ufoy[t]) + ufo_yoff
            end
            check (ufo_points, testx, testy, bxp, byp)
            if col == 1 then crashed = 1; ufo = 0; ufo_hit_ship = 1; last_ship = os.time() ; end
         end
      end
   end
end

function check(npol, xp, yp, xp1, yp1)
   col = 0 ;  j = npol
   for i = 1,npol do
      if ((((yp[i] <= yp1) and (yp1 <yp[j])) or ((yp[j] <= yp1) and (yp1 < yp[i]))) and (xp1<((((xp[j]-xp[i])*(yp1-yp[i]))/(yp[j]-yp[i]))+xp[i]))) then
        if col == 0 then col = 1 else col = 0  end
      end
      j = i
   end
end

function savehi()
  file = io.open(hifile, "w")
  if file then file:write(score .. "\n") ; file:close() ; end
end

function loadhi()
  file = io.open(hifile, "r")
  if file then hi_score = file:read("*n") ;   file:close(); end
end

function save_options()
  file = io.open(options_file, "w")
  if file then
     file:write(start_rocks .. "\n")
     file:write(rock_cap .. "\n")
     file:write(spawn_time .. "\n")
     file:write(colored_rocks .. "\n")
     file:write(back .. "\n")
     file:write(rock_mod .. "\n")
     file:write(max_rock_vel .. "\n")
     file:write(max_life .. "\n")
     file:write(rock_type .. "\n")
     file:close()
  end
end

function load_options()
  file = io.open(options_file, "r")
  if file then
     start_rocks = file:read("*n")
     rock_cap = file:read("*n")
     spawn_time = file:read("*n")
     colored_rocks = file:read("*n")
     back = file:read("*n")
     rock_mod = file:read("*n")
     max_rock_vel = file:read("*n")
     max_life = file:read("*n")
     rock_type = file:read("*n")
     file:close()
  end
end

function play()

   pad = Controls.read()
   analog()

   if pad:up() then
     if no_ship ~= 1 then
        thrust_chg =  thrust_step ; new_thrust_angle = cur_angle ; boost = 1 ; step = 0
     end
   end
   if pad:square() then
      if no_ship ~= 1 then
         thrust_chg =  thrust_step ; new_thrust_angle = cur_angle ; boost = 1 ; step = 0
      end
   end
   if pad:left() or bt == 1 then
      if no_ship ~= 1 then
         cur_angle = cur_angle + turn
      end
   end
   if pad:right() or bt == 2 then
     if no_ship ~= 1 then
        cur_angle = cur_angle - turn
     end
   end
   if pad:triangle() then
      if no_ship ~= 0 then
         no_ship = 0;
      end
   end
   if pad:circle() then
      if no_ship ~= 1 then
         if os.difftime (os.time(), last_time) > .5 then
            xoff = math.random(440)+20 ; yoff = math.random(232)+20 ; thrust = 0
            last_time = os.time()
            if math.random(4) == 4 then crashed = 1 end
         end
      end
   end
   if pad:cross() then
      if no_ship ~= 1 then
         if db ~= 1 then
            shot:play()
            bullet_xoff = xn[2] + xoff ; bullet_yoff = yn[2] + yoff ; db = 1 ; bullet_dis = 1 ; bullet_ang = cur_angle
            bullet_xoff = bullet_xoff + 7*math.sin(math.rad(bullet_ang))
            bullet_yoff = bullet_yoff + 7*math.cos(math.rad(bullet_ang))
         end
      end
   end
   if pad:select() then
      oldpad = pad ; reset_game(); options() ;  init()
   end
   if cur_angle > 360 then cur_angle = cur_angle - 360 end
   if cur_angle < 0 then cur_angle = cur_angle + 360 end
   bt = 0
end

function disp()
  screen:clear()
  if back == 1 then screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false) end
  life()
  rotate()
  if no_ship ~=1 then set_thrust() end
  if no_ship ~=1 then draw_ship(green) else draw_ship(grey)  end
  draw_rock()
  if ufo == 0 and no_ship == 0 then make_ufo() end
  if ufo == 1 then draw_ufo() end
  if ufo == 1 and dbu ~=1 then shoot_ufo() end
  if dbu == 1 then draw_ufo_bullet() end
  if dbu == 1 then check_ship_hit() end
  if dbu == 1 then check_ufo_bullet_rock_hit() end
  if db == 1 then draw_bullet() end
  if db == 1 then check_bullet_hit_rock() end
  if db == 1 and ufo == 1 then check_bullet_hit_ufo() end
  if no_ship ~= 1 then crash_rock_check() end
  if no_ship ~= 1 and ufo == 1 then crash_ufo_check() end
  if no_ship ~= 1 then did_crash() end
  if cleared_rocks == 1 then
     no_ship = 1 ; cleared_rocks = 0 ; init()
  end
  if no_ship == 1 then
     screen:print(125,230,"Press     to spawn your ship",yellow);
     screen:blit(170,218,triangle)
  end
  screen:print(15,8,"Wave " .. wave,yellow) ; screen:print(15,20,score,yellow); screen:print(225,8,hi_score,yellow)
  screen.flip()
  screen.waitVblankStart()
end

-- Begin here
loadhi()
load_options()
intro()
init()

while true do
 play()
 disp()
end
